package diplomka.pef.czu.diplomka.NetworkList;

public class NonSelectableNetworkInfo implements INetworksListItem {
	private int frequency;
	private int level;
	private String network;
	private boolean selected;
	private String security;
	private boolean secured;
	private String ssid;

	public NonSelectableNetworkInfo(){
		this.frequency = 0;
		this.level = 0;
		this.network = null;
		this.selected = false;
		this.secured = false;
		this.security="FREE";
		this.ssid = "";
	}

	public NonSelectableNetworkInfo(String SSID, int frequency, int level, String network, String capabilities){
		this.frequency = frequency;
		this.level = level;
		this.network = network;
		this.selected = false;
		this.ssid = SSID;
		setSecure(capabilities);

	}


	public int getLevel(){
		return level;
	}

	public int getFrequency(){
		return frequency;
	}

	public String getNetwork(){
		return network;
	}

	@Override
	public boolean isSection() {
		return false;
	}

	public boolean isSelected(){
		return selected;
	}

	public void setSelected(boolean selected){
		this.selected=selected;
	}

	public boolean isSecured(){
		return secured;
	}

	public String getSecure(){
		return security;
	}

	private void setSecure(String capabilities){
		if(capabilities.contains("WEP")){
			this.security = "WEP";
		}else if(capabilities.contains("WPA2-PSK")){
			this.security = "WPA2-PSK";
		}else if(capabilities.contains("WPA2")){
			this.security = "WPA2";
		}else if(capabilities.contains("WPA")){
			this.security = "WPA";
		}else{
			this.security = "FREE";
			this.secured = false;
			return;
		}
		this.secured = true;
	}

	@Override
	public boolean isNonSelcetableItem() {
		return true;
	}

	@Override
	public String getSSID() {
		return this.ssid;
	}

	@Override
	public NetworkInfo toNetworkInfo() {
		return new NetworkInfo(ssid,frequency, level, network,security);
	}


	@Override
	public NonSelectableNetworkInfo toNonSelectableNetworkInfo() {
		return this;
	}


}
