package diplomka.pef.czu.diplomka.dataview;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.util.AttributeSet;
import android.view.View;

import czu.pef.diplomka.bp.myGraphView.*;


/**
 * Created by Roman on 12.2.2018.
 */

public class DataView extends View {

    private Bitmap b;
    private GraphAxis graphAxis;
    private GraphParams graphParams = null;
    private GraphHelpLines graphHelpLines;

    public DataView(Context context) {
        super(context);
        init();

    }

    public DataView(Context context, AttributeSet attrs){
        super(context,attrs);
        init();
    }

    private void init(){
        b = Bitmap.createBitmap(100,100,Bitmap.Config.ARGB_8888);
        graphParams = new GraphParams();

    }

    @SuppressLint("DrawAllocation")
    @Override
    protected void onDraw(Canvas canvas){
        super.onDraw(canvas);
        drawGraphSheet(canvas);


    }

    //draw graphSheet to the canvas
    private void drawGraphSheet(Canvas canvas){
        graphParams.set(canvas);
        graphAxis = new GraphAxis(canvas, graphParams);
        graphHelpLines = new GraphHelpLines(canvas, graphParams);
        graphAxis.draw();
        graphHelpLines.draw();
    }
}
