package diplomka.pef.czu.diplomka.main;

import android.content.Context;
import android.os.Bundle;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

import com.jjoe64.graphview.GraphView;
import com.jjoe64.graphview.helper.DateAsXAxisLabelFormatter;
import com.jjoe64.graphview.series.DataPoint;
import com.jjoe64.graphview.series.LineGraphSeries;
import com.opencsv.CSVReader;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import czu.pef.diplomka.R;
import czu.pef.diplomka.bp.GraphActivity.Fragments.GraphFragment;
import diplomka.pef.czu.diplomka.other.GraphLegendItemListAdapter;
import diplomka.pef.czu.diplomka.other.GraphSeriesWrapper;
import diplomka.pef.czu.diplomka.other.MyColors;
import diplomka.pef.czu.diplomka.viewFragments.LoadDataFragment;


/**
 * Created by Roman on 11.2.2018.
 */

public class LoadDataActivity extends AppCompatActivity  implements AdapterView.OnItemClickListener {

    private GraphView graph = null;
    private GraphFragment.OnGraphItemSelectedListener mCallBack;
    private CSVReader reader = null;
    private GraphLegendItemListAdapter  mListAdapter = null;
    private ListView mLegendListView; //legends
    //private List<DataPoint> dataPoints = null;
    private HashMap<String, GraphSeriesWrapper> dataPointListHash = null;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_loaddata);
        graph = (GraphView) findViewById(R.id.graph);
        mLegendListView = (ListView)findViewById(R.id.graphLegendView);

        File sdCard = Environment.getExternalStorageDirectory();
        File dir = new File (sdCard+ File.separator +"diplomka");
        String[] fileNames = getIntent().getExtras().getStringArray("csvFileNames");
        long  startSeries = Long.MAX_VALUE;
        dataPointListHash = new HashMap<String,GraphSeriesWrapper>();
        int color = 0;
        //cyklus pro vsechny vybrane soubory
        for(String fileName : fileNames) {
            File file = new File(dir, fileName);
            //List<DataPoint> dataPoints = new ArrayList<>();
            GraphSeriesWrapper seriesWrapper;
            //HashMap<String, List<DataPoint>> dataPointListHash = new HashMap<String,List<DataPoint>>();
            //dataPointListHash = new HashMap<String,GraphSeriesWrapper>();

            try {
                reader = new CSVReader(new FileReader(file), ',', '"', 1);
                String[] nextLine;

                //cteme file po radcich
                while ((nextLine = reader.readNext()) != null) {
                    if (nextLine != null) {
                        //koukneme do hashmapy jestli tam dana sit uz neni
                        //unikatnost je nazev site a nazev souboru (muzeme jednu sit merit ve vice dnech tedy souborech)
                        String keyString = fileName.split(".csv")[0] + "_" + nextLine[1];
                        if(dataPointListHash.containsKey(keyString)){//pokud je vytaneme si List<DataPoint>
                            seriesWrapper = dataPointListHash.get(keyString);

                        }else{//pokud ne tak vytvorime novy List<DataPoint>

                            seriesWrapper = new GraphSeriesWrapper();
                            seriesWrapper.setColor(MyColors.get(color++));
                            //seriesWrapper.setNetworkName(nextLine[1]);
                            seriesWrapper.setNetworkName(keyString);
                            dataPointListHash.put(keyString,seriesWrapper);
                        }
                        //Verifying the read data here

                        seriesWrapper.addDataPoint(Long.valueOf(nextLine[0]),Integer.valueOf(nextLine[2]));
                    }
                }

            } catch (Exception e) {
                e.printStackTrace();
            }
        }// tady konci cyklus kde projizdime vsechny csv soubory


        //nejdem serii ktera zacina nejdriv a podle ni nastavime u ostatnich difference

        for(GraphSeriesWrapper wrapper : dataPointListHash.values()){
            if(wrapper.getStartTime() <= startSeries) startSeries = wrapper.getStartTime();
        }
        //den v poradi nejdrivejsi serie
        long startDay = (startSeries / (60*60*24*1000));
        for(GraphSeriesWrapper wrapper : dataPointListHash.values()){
            //long currDay = (wrapper.getStartTime() / (60*60*24*1000));
            long currDay = (wrapper.getStartTimeInDays());
            if(startDay != currDay){
                //rozdil ve dnech
                wrapper.setDifference(currDay-startDay);
            }
        }

        //int color = 0;
        //vsechny site z hashmapy pridame do grafu

        for(GraphSeriesWrapper wrapper : dataPointListHash.values()){
            LineGraphSeries<DataPoint> series = wrapper.getGraphSeries();
            series.setColor(wrapper.getColor());
            graph.addSeries(series);

        }

        makeLegend();


        //2graph.addSeries(series);
        // set date label formatter
        graph.getGridLabelRenderer().setLabelFormatter(new DateAsXAxisLabelFormatter(this));
        graph.getGridLabelRenderer().setNumHorizontalLabels(3); // only 4 because of the space
        graph.getGridLabelRenderer().setTextSize(20);
        // enable scaling and scrolling
        graph.getViewport().setScalable(true);
        graph.getViewport().setScalableY(true);

        graph.getViewport().setXAxisBoundsManual(true);
    }

    private void init(){
    }


    private void makeLegend(){
        mListAdapter = new GraphLegendItemListAdapter(this,new ArrayList(dataPointListHash.values()));
        mLegendListView.setAdapter(mListAdapter);
        mLegendListView.setOnItemClickListener(this);

        //mLegendListView.setOnItemClickListener(this);
        //mLegendContent.setAllItemChecked(mLegendListView);

    }

    @Override
    public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
        //mLegendListView.setItemChecked(i, true);
        onClickRedrawGraph(i);
    }

    public void onClickRedrawGraph(int position){
        graph.removeAllSeries();
        int i=0;
        for(GraphSeriesWrapper wrapper : dataPointListHash.values()){
            LineGraphSeries<DataPoint> series = wrapper.getGraphSeries();
            series.setColor(wrapper.getColor());
            if(i==position) wrapper.onClick();//zmeni visible
            mLegendListView.setItemChecked(position, wrapper.getVisivble());
            if(wrapper.getVisivble()==true){
                graph.addSeries(series);
            }

            i++;

        }
    }
}