package diplomka.pef.czu.diplomka.main;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiManager;
import android.os.Environment;
import android.text.format.Formatter;
import android.widget.TextView;
import android.widget.Toast;

import com.opencsv.CSVWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import diplomka.pef.czu.diplomka.threads.ServerSocketThread;

import static android.content.Context.CONNECTIVITY_SERVICE;
import static android.net.wifi.WifiManager.RSSI_CHANGED_ACTION;
import static java.net.InetAddress.getByName;

/**
 * Created by Roman on 11.2.2018.
 */

public class MeasureAndStore{

    private String dstAddress;
    private int dstPort;
    private TextView textview;
    private CSVWriter csvWriter;
    private Socket socket = null;
    private long speedDownlod;
    private long pingTime;
    private InetAddress in;
    private WifiManager wifiManager;
    private String csvFileName;
    private static final int TIMEOUT = 1000;
    private String[] SSIDs;
    IntentFilter intentfilterState;
    public boolean isConnected;


    /*public MeasureAndStore(int port,TextView textview,WifiManager wifiManager, String csvFileName, String[] SSIDs){
        this.dstPort = port;
        this.textview = textview;
        this.wifiManager = wifiManager;
        this.dstAddress = Formatter.formatIpAddress(this.wifiManager.getConnectionInfo().getIpAddress());
        this.csvFileName = csvFileName;
        this.SSIDs = SSIDs;

    }*/


    public void doJob(final Context mContext) {


       /* BroadcastReceiver nsca =new BroadcastReceiver(){

            @Override
            public void onReceive(Context context, Intent intent) {
                isConnected = true;
                Toast.makeText(mContext, "Connected",
                        Toast.LENGTH_LONG).show();
                ConnectivityManager mgr = (ConnectivityManager) context
                        .getSystemService(Context.CONNECTIVITY_SERVICE);
                NetworkInfo networkInfo = mgr
                        .getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                if(networkInfo!=null &&  networkInfo.isConnected()){
                    isConnected = true;
                }

            }



        };*/





        //intentfilterState = (IntentFilter)new IntentFilter();
        //intentfilterState.addAction(WifiManager.NETWORK_STATE_CHANGED_ACTION);
        //mContext.registerReceiver(nsca, new IntentFilter(WifiManager.RSSI_CHANGED_ACTION));

        List<WifiConfiguration> wifiConf = wifiManager.getConfiguredNetworks();

        //projedem vsechny ssid ktere chceme merit
        for(String SSID : SSIDs){

            //hledame jestli ma android sit ulozenou
            for(final WifiConfiguration wc : wifiConf){
                if(wc.SSID.contains(SSID) ){
                    wifiManager.disconnect();
                    isConnected = false;
                    //mContext.registerReceiver(nsca, intentfilterState);
                    //mContext.registerReceiver(nsca, new IntentFilter(WifiManager.RSSI_CHANGED_ACTION));
                    //klaplo to. Jdem na mereni :
                    wifiManager.enableNetwork(wc.networkId, true);
                    wifiManager.reconnect();
                    wifiManager.reassociate();
                    long curr = Calendar.getInstance().getTimeInMillis();
                    //while(Calendar.getInstance().getTimeInMillis()<(curr+5000)){}
                    //while(isConnected==false){}
                    ConnectivityManager mgr = (ConnectivityManager) mContext
                            .getSystemService(Context.CONNECTIVITY_SERVICE);
                    android.net.NetworkInfo networkInfo = mgr
                            .getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                    while(!networkInfo.isConnected()){
                        networkInfo= mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                    }
                    //ServerSocketThread serverSocketThread = new ServerSocketThread(textview); // vytvorime a nastartuejeme znovu vlakno
                    //serverSocketThread.start();
                    textview.setText(textview.getText() + "\n" +  "lets measure ");
                    testPing();
                    testDownload();
                    addToCvs();
                    //serverSocketThread.interrupt();
                }
            }
        }
        testPing();
        testDownload();
        addToCvs();
    }

    public void testDownload(){
        try{
            byte[] bytes;
            //while(true) {
            socket = new Socket(dstAddress, dstPort);
            long currentTime = System.currentTimeMillis();
            InputStream inputStream = socket.getInputStream();

            //prijeti obrazku
            File file = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS) + "/test.pdf");

            ObjectInputStream ois = new ObjectInputStream(inputStream);
            bytes = (byte[]) ois.readObject();
            currentTime = System.currentTimeMillis() - currentTime;
            //textview.setText(textview.getText() + "\nPrijato " + bytes.length + "bytes in " + currentTime + " ms" );
            speedDownlod = (bytes.length*8*(1000/currentTime)/1024/1024);
            final String message = "\nPrijato " + bytes.length + "bytes in " + currentTime + " ms - " + speedDownlod + " Mbps\nPing: " + this.pingTime;
            textview.post(new Runnable() {
                @Override
                public void run() {
                    textview.setText(textview.getText() + message);
                }
            });
            //FileOutputStream fos = new FileOutputStream(file);
            //fos.write(bytes);
        }catch(Exception e){
            final Exception er = e;
            textview.post(new Runnable() {
                @Override
                public void run() {
                    textview.setText(textview.getText() + "\n" +  "Error recieving " + er.getLocalizedMessage());
                }
            });
        }
    }

    public void testPing(){
        pingTime = -1;
        long time;
        try {
            in = getByName(dstAddress);
            time = System.currentTimeMillis();
            if (in.isReachable(TIMEOUT)) {
                pingTime = System.currentTimeMillis() - time;
            }else{
                pingTime = -1;
            }
        }catch (Exception  e) {
            pingTime = -1;
        }
    }

    private void addToCvs(){
        File sdCard = Environment.getExternalStorageDirectory();
        File dir = new File (sdCard+ File.separator +"diplomka");
        if(!dir.exists()){
            dir.mkdir();
        }
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String currentDateTime = dateFormat.format(new Date());
        File file  = new File(dir, this.csvFileName + ".csv");
        try {
            //writer = new CSVWriter(new FileWriter(file),'\t');
            csvWriter = new CSVWriter(new FileWriter(file,true));
        } catch (IOException e) {
            e.printStackTrace();
        }
        List<String[]> rows = new ArrayList<String[]>();
        String[] columns = new String[8];
        columns[0] = String.valueOf(Calendar.getInstance().getTime().getTime());
        columns[1] = wifiManager.getConnectionInfo().getSSID();
        columns[2] = String.valueOf(speedDownlod);
        columns[3] = String.valueOf(pingTime);
        columns[4] = String.valueOf(wifiManager.getConnectionInfo().getFrequency());
        columns[5] = String.valueOf(wifiManager.getConnectionInfo().getIpAddress());
        columns[6] = String.valueOf(wifiManager.getConnectionInfo().getLinkSpeed());
        columns[7] = wifiManager.getConnectionInfo().getMacAddress();
        rows.add(columns);
        csvWriter.writeNext(columns);
        try {
            csvWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
