package diplomka.pef.czu.diplomka.main;

/**
 * Created by Roman on 8.2.2018.
 */

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.net.ConnectivityManager;
import android.net.wifi.WifiConfiguration;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.support.v7.app.AppCompatActivity;
import android.net.wifi.WifiManager;
import android.text.format.Formatter;
import android.widget.ProgressBar;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;


import czu.pef.diplomka.R;
import diplomka.pef.czu.diplomka.NetworkList.NetworkInfo;
import diplomka.pef.czu.diplomka.other.MyWakefulReceiver;
import diplomka.pef.czu.diplomka.zUnused.ClientThread;
import diplomka.pef.czu.diplomka.threads.MeasureAndStoreThread;
import diplomka.pef.czu.diplomka.zUnused.PingThread;
import diplomka.pef.czu.diplomka.threads.ServerSocketThread;
import diplomka.pef.czu.diplomka.threads.TimerBroadcastService;

public class ThroughputMeasuringActivity extends AppCompatActivity{

    private TextView timerCounter;
    private TextView textview;
    private TextView downloadTextView;
    private TextView pingTextView;
    private WifiManager wifiManager;
    private ProgressBar progressBar;
    private String ipaddr;
    private Bundle extras;
    private String csvFileName;
    private long interval;
    private String[] SSIDs;
    private Context context;

    ServerSocketThread serverSocketThread;
    ClientThread clientThread;
    PingThread pingThread;
    MeasureAndStoreThread measureThtead;
    MeasureAndStore measureAndStore;
    CountDownTimer countdowntimer;



    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        extras = getIntent().getExtras();
        setContentView(R.layout.acitivity_measure_throughput);
        init();
        //connectWifi();
        //countdowntimer.start();
        serverSocketThread.start();
        measureThtead.start();
        //measureAndStore.doJob(this);

        /* tohle dam zatim pryc a zkusim wake up boradcats
        Intent intent = new Intent(this, TimerBroadcastService.class);
        intent.putExtra("csvFileName",getIntent().getExtras().getString("csvFileName"));
        intent.putExtra("interval",  getIntent().getExtras().getLong("interval"));
        intent.putParcelableArrayListExtra("networks",  getIntent().getExtras().getParcelableArrayList("networks"));
        startService(intent);
        */
        Intent intent = new Intent(ThroughputMeasuringActivity.this, MyWakefulReceiver.class);
        intent.putExtra("csvFileName",getIntent().getExtras().getString("csvFileName"));
        intent.putExtra("interval",  getIntent().getExtras().getLong("interval"));
        intent.putParcelableArrayListExtra("networks",  getIntent().getExtras().getParcelableArrayList("networks"));
        PendingIntent pendingIntent = PendingIntent.getBroadcast(ThroughputMeasuringActivity.this, 0, intent, 0);
        AlarmManager alarmManager = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
        alarmManager.setExact(AlarmManager.RTC_WAKEUP, 1000, pendingIntent);


    }

    @Override
    protected void onStart() {
        super.onStart();
        /*Intent intent = new Intent(this, TimerBroadcastService.class);
        intent.putExtra("csvFileName",getIntent().getExtras().getString("csvFileName"));
        intent.putExtra("interval",  getIntent().getExtras().getLong("interval"));
        intent.putParcelableArrayListExtra("networks",  getIntent().getExtras().getParcelableArrayList("networks"));
        startService(intent);*/
        //countdowntimer.start();
    }

    @Override
    public void onResume() {
        super.onResume();
        registerReceiver(br, new IntentFilter(TimerBroadcastService.COUNTDOWN_BR));
        registerReceiver(br, new IntentFilter(TimerBroadcastService.FINISH_BR));
    }

    @Override
    protected void onPause() {
        super.onPause();
        //unregisterReceiver(br);
    }

    @Override
    public void onDestroy() {
        stopService(new Intent(this, TimerBroadcastService.class));
        super.onDestroy();
    }

    private void init(){
        getExtras(extras);
        wifiManager = (WifiManager)getApplicationContext().getSystemService(getApplicationContext().WIFI_SERVICE);
        progressBar = (ProgressBar)findViewById(R.id.progressBar);
        timerCounter = (TextView)findViewById(R.id.timerCounter);
        textview = (TextView)findViewById(R.id.ipaddress);
        downloadTextView = (TextView)findViewById(R.id.downloadInfo);
        pingTextView = (TextView)findViewById(R.id.pingTime);
        ipaddr =  getIpAdress();
        textview.setText(getIpAdress());
        textview.post(new Runnable() {
            @Override
            public void run() {
                textview.setText(textview.getText() +"\nFrequency " +  String.valueOf(wifiManager.getConnectionInfo().getFrequency()));
            }
        });
        //connectWifi();
        serverSocketThread = new ServerSocketThread(downloadTextView);
        measureThtead = new MeasureAndStoreThread(8080,downloadTextView,wifiManager,csvFileName);
        countdowntimer = new CountDownTimerClass(interval, 1000, this);
        //measureAndStore = new MeasureAndStore(8080,downloadTextView,wifiManager,csvFileName, SSIDs);
        //registerReceiver(nsca, new IntentFilter(WifiManager.RSSI_CHANGED_ACTION));
        context = this;
    }

    public String getIpAdress(){
        @SuppressWarnings("deprecation")
        String ip = Formatter.formatIpAddress(wifiManager.getConnectionInfo().getIpAddress());
        return ip;
    }

    //vytahne extras z Bndle
    private void getExtras(Bundle extras){

        csvFileName = extras.getString("csvFileName");
        interval = extras.getLong("interval");
        ArrayList<NetworkInfo> parcelableArray ;
        parcelableArray = extras.getParcelableArrayList("networks");
        SSIDs = new String[parcelableArray.size()];
        for(int i=0;i<parcelableArray.size();i++){
            SSIDs[i] = ((NetworkInfo)parcelableArray.get(i)).getSSID();
        }
    }


    //inner class
    public class CountDownTimerClass extends CountDownTimer {
        long millisInFuture;
        long countDownInterval;
        Context mContext;
        public CountDownTimerClass(long millisInFuture, long countDownInterval, Context con) {
            super(millisInFuture, countDownInterval);
            this.millisInFuture = millisInFuture;
            this.countDownInterval = countDownInterval;
            this.mContext = con;
            progressBar.setMax((int)millisInFuture/1000);
        }

        @Override
        public void onTick(long millisUntilFinished) {

            int progress = (int) (millisUntilFinished/1000);
            long millis = millisUntilFinished;
            String hms = String.format("%02d:%02d:%02d", TimeUnit.MILLISECONDS.toHours(millis), TimeUnit.MILLISECONDS.toMinutes(millis) - TimeUnit.HOURS.toMinutes(TimeUnit.MILLISECONDS.toHours(millis)), TimeUnit.MILLISECONDS.toSeconds(millis) - TimeUnit.MINUTES.toSeconds(TimeUnit.MILLISECONDS.toMinutes(millis)));

            timerCounter.setText(hms);
            progressBar.setProgress(progressBar.getMax()-progress);
        }
        @Override
        public void onFinish() {
            timerCounter.setText("MEASURING");

            List<WifiConfiguration> wifiConf = wifiManager.getConfiguredNetworks();
            //projedem vsechny ssid ktere chceme merit
            for(String SSID : SSIDs){
                //hledame jestli ma android sit ulozenou
                for(final WifiConfiguration wc : wifiConf){
                    //nasli sme a jdem na mereni
                    if(wc.SSID.contains(SSID) ) {
                        wifiManager.disconnect();
                        wifiManager.enableNetwork(wc.networkId, true);
                        wifiManager.reconnect();
                        wifiManager.reassociate();
                        ConnectivityManager mgr = (ConnectivityManager) mContext.getSystemService(Context.CONNECTIVITY_SERVICE);
                        android.net.NetworkInfo networkInfo = mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                        //cekame dokud se wifi nepripoji
                        while (!networkInfo.isConnected()) {
                            networkInfo = mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                        }
                        measureThtead = new MeasureAndStoreThread(8080,downloadTextView,wifiManager,csvFileName);
                        measureThtead.start();
                        while(measureThtead.getState() != Thread.State.TERMINATED){}

                    }

                }

            }


            textview.post(new Runnable() {
                @Override
                public void run() {
                    textview.setText(textview.getText() +"\nLink speed " +  wifiManager.getConnectionInfo().getLinkSpeed());
                }
            });

            this.start();
        }
    }



    //broadcast receiver z Timer vlakna
    private BroadcastReceiver br = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            if(intent.getAction().equals(TimerBroadcastService.COUNTDOWN_BR)){
                long millisUntilFinished = intent.getLongExtra("countdown", 0);
                int progress = (int) (millisUntilFinished/1000);
                long millis = millisUntilFinished;
                String hms = String.format("%02d:%02d:%02d", TimeUnit.MILLISECONDS.toHours(millis), TimeUnit.MILLISECONDS.toMinutes(millis) - TimeUnit.HOURS.toMinutes(TimeUnit.MILLISECONDS.toHours(millis)), TimeUnit.MILLISECONDS.toSeconds(millis) - TimeUnit.MINUTES.toSeconds(TimeUnit.MILLISECONDS.toMinutes(millis)));

                timerCounter.setText(hms);
                progressBar.setProgress(progressBar.getMax()-progress);
            }else if(intent.getAction().equals(TimerBroadcastService.FINISH_BR)){

                timerCounter.setText("MEASURING");

            }


            //updateGUI(intent); // or whatever method used to update your GUI fields
        }
    };

}
