package diplomka.pef.czu.diplomka.main;

import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.EditText;
import android.widget.NumberPicker;
import android.widget.RadioGroup;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.List;
import czu.pef.diplomka.R;
import czu.pef.diplomka.bp.GraphActivity.Fragments.MyFragmentPagerAdapter;
import diplomka.pef.czu.diplomka.viewFragments.LoadDataFragment;
import diplomka.pef.czu.diplomka.viewFragments.SetMeasureFragment;

/**
 * Created by Roman on 27.1.2018.
 */

public class ThroughputSettingActivity extends AppCompatActivity implements LoadDataFragment.OnItemListSelectedListener{

    private MyFragmentPagerAdapter fragmentAdapter; //adapter for fragments
    private SetMeasureFragment setMeasureFragment; // fragment with setmeasurefragment view
    private  LoadDataFragment loadMeasureFragment; //fragment with loaddatafrgment view
    private TabLayout tabLayout; // android TabLayout
    private ViewPager viewPager; // viewPager
    private EditText fileName;
    private List<Integer> selectedItems; // udrzuje indexy oznacenych itemu
    private RadioGroup radioGroup;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);


        setContentView(R.layout.activity_setting_throughput);
        init();
    }


    private void init(){
        tabLayout = (TabLayout) findViewById(R.id.sliding_tabs);
        viewPager = (ViewPager) findViewById(R.id.viewpager);
        viewPager.setOffscreenPageLimit(2);//set all three fragments alive while off screen
        fragmentAdapter = new MyFragmentPagerAdapter(getSupportFragmentManager());
        setMeasureFragment = new SetMeasureFragment();
        loadMeasureFragment = new LoadDataFragment();
        //set adapter and pager:
        fragmentAdapter.addFragment(setMeasureFragment, "NOVÉ MĚŘENÍ");
        fragmentAdapter.addFragment(loadMeasureFragment, "NAČÍST DATA");
        viewPager.setAdapter(fragmentAdapter);
        viewPager.setCurrentItem(0);
        //Give the TabLayout the ViewPager
        tabLayout.setupWithViewPager(viewPager);
        selectedItems = new ArrayList<Integer>();
    }

    //spusti novou aktivitu s nastavenim mereni propustnosti
    public void startNetworkSelectActivity(View view){
        //Intent intent = new Intent(this, ThroughputMeasuringActivity.class);
        Intent intent = new Intent(this, NetworkSelectActivity.class);
        if(checkFileName()!=null){
            intent.putExtra("csvFileName",checkFileName());
            startActivity(intent);
        }else{
            Toast.makeText(getApplicationContext(), "Zadejte nazev souboru", Toast.LENGTH_LONG).show();
        }

        intent.putExtra("interval",setMeasureFragment.getInterval());
        startActivity(intent);
    }

    //spusti novou aktivitu pro nacteni a zobrazeni dat
    public void startLoadDataActivity(View view){
        //Intent intent = new Intent(this, ThroughputSettingActivity.class);
        Intent intent = new Intent(this, LoadDataActivity.class);
        if(selectedItems!=null && selectedItems.size()>0){
            intent.putExtra("csvFileNames",loadMeasureFragment.getSelectedFileNames());
            startActivity(intent);
        }else{
            Toast.makeText(getApplicationContext(), "Žadný soubor nebyl vybrán", Toast.LENGTH_LONG).show();
        }

    }
    //zkontroluje jestli je zadan nazev csv souboru
    private String checkFileName(){
        fileName = setMeasureFragment.getCsvFileName();
        if(fileName ==null || fileName.getText().toString() == null || fileName.getText().toString().equals("")) return null;
        return fileName.getText().toString();
    }

    @Override
    public void onItemListSelected(int position) {
        loadMeasureFragment.clickListViewItem(position);
        boolean value = selectedItems.contains(position);
        if(value){
            int i =  selectedItems.indexOf(position);
            selectedItems.remove(i);
        }else{
            selectedItems.add(new Integer(position));
        }
    }

}
