package diplomka.pef.czu.diplomka.other;

import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import java.util.ArrayList;

import czu.pef.diplomka.R;

/**
 * Created by Roman on 18.3.2018.
 */

public class GraphLegendItemListAdapter extends ArrayAdapter<GraphSeriesWrapper> {

    private ArrayList<GraphSeriesWrapper> mListItems;
    private LayoutInflater mLayoutInflater;

    public GraphLegendItemListAdapter(Context context, ArrayList<GraphSeriesWrapper> items){
        super(context,0,items);

        this.mListItems = items;
        this.mLayoutInflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

    }

    @Override
    public int getCount() {
        return mListItems.size();
    }

    @Override
    public GraphSeriesWrapper getItem(int position){
        return mListItems.get(position);
    }

    @SuppressLint("InflateParams")
    @Override
    public View getView(int position, View convertView, ViewGroup parent){
        View view = convertView;

        final GraphSeriesWrapper listItem = mListItems.get(position);
        if(listItem != null){

            GraphSeriesWrapper legendItem = (GraphSeriesWrapper) listItem;
            view = mLayoutInflater.inflate(R.layout.graph_legend_item , null);


            final TextView textLegend = (TextView) view.findViewById(R.id.graph_legend_text);
            String text = legendItem.getAsText();
            textLegend.setText(text);
            final int color = legendItem.getColor();
            textLegend.setTextColor(color);

        }
        return view;
    }



}
