package diplomka.pef.czu.diplomka.other;

import com.jjoe64.graphview.series.DataPoint;
import com.jjoe64.graphview.series.LineGraphSeries;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * Created by Roman on 4.3.2018.
 */

public class GraphSeriesWrapper {

    private  List<DataPoint> dataPointList = null;
    private int color;
    private int avg;
    private int minValue;
    private int maxValue;
    private long startTime= Long.MAX_VALUE;
    private long endTime = -1;
    private boolean visible = true;
    private String networkName = "";
    SimpleDateFormat df = new SimpleDateFormat("dd.MM.yy HH:mm:ss");
    /*casovy rozdil od serie s nejmensim casem startu
        je to proto aby se pr vykreslovani grafu smazali rozdili dnu a grafy zacinalu jen na zaklade casu
    */
    private long difference = 0;

    public GraphSeriesWrapper(){
        this.dataPointList = new ArrayList<>();
        minValue = Integer.MAX_VALUE;
        maxValue = Integer.MIN_VALUE;
        visible = true;
        avg = 0;

    }

    public void addDataPoint(long x, int y){

        dataPointList.add(new DataPoint(new Date(Long.valueOf(x)), Integer.valueOf(y)));
        if(x < startTime) startTime = x;
        if(x > endTime) endTime = x;
        if(y < minValue) minValue =y;
        if(y > maxValue) maxValue =y;
        avg = (avg+y)/2;
    }

    public LineGraphSeries<DataPoint> getGraphSeries(){

        return new LineGraphSeries<>(this.dataPointList.toArray(new DataPoint[dataPointList.size()]));
    }

    //vrati start daneho serie
    public long getStartTime(){
        return startTime;
    }

    public long getStartTimeInDays(){
        return startTime / (60*60*24*1000);
    }

    //vrati posledni cas dane serie
    public long getEndTime(){
        return endTime;
    }

    public void setNetworkName(String name){
        this.networkName = name;
    }

    public void setDifference(long diffDays){
        //chceme vymazat jen rozdily dnu

            // vypocteme o kolik dnu musime posunout
            this.difference = (diffDays*TimeUnit.DAYS.toMillis(1));
            //pozor musi se prepocitat jen jednou
            List<DataPoint> newList = new ArrayList<>();
            //kazdy bod na ose x poseuneme o difference
            for(DataPoint dp : dataPointList){
                newList.add(new DataPoint(new Date((long)dp.getX()-this.difference), (int)dp.getY()));
            }
            this.dataPointList = newList;
    }

    public String getAsText(){
        Date startDate = new Date(startTime);
        Date endDate = new Date(endTime);
        return  "nazev: " + networkName + ", cas: " + df.format(startDate) + "-" +df.format(endDate)  + ", prum: "+ avg + "Mbps" +" , min: " + minValue + "Mbps" + ", max: " + maxValue + "Mbps";
    }

    public void setColor(int val){
        this.color = val;
    }

    public void setName(String name){
        this.networkName = name;
    }

    public int getColor(){
        return color;
    }

    public void setVisible(boolean val){
        this.visible = val;
    }

    public boolean getVisivble(){
        return this.visible;
    }

    public void onClick(){
        visible = !visible;
    }
}
