package diplomka.pef.czu.diplomka.threads;

import android.net.wifi.WifiManager;
import android.os.Environment;
import android.text.format.Formatter;
import android.widget.TextView;
import com.opencsv.CSVWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import static java.net.InetAddress.getByName;

/**
 * Created by Roman on 11.2.2018.
 */

public class MeasureAndStoreThread extends Thread{

    private String dstAddress;
    private int dstPort;
    private TextView textview;
    private CSVWriter csvWriter;
    private Socket socket = null;
    private long speedDownlod;
    private long pingTime;
    private InetAddress in;
    private WifiManager wifiManager;
    private String csvFileName;
    private static final int TIMEOUT = 1000;


    public MeasureAndStoreThread(int port,TextView textview,WifiManager wifiManager, String csvFileName){
        this.dstPort = port;
        this.textview = textview;
        this.wifiManager = wifiManager;
        this.dstAddress = Formatter.formatIpAddress(this.wifiManager.getConnectionInfo().getIpAddress());
        this.csvFileName = csvFileName;
    }

    @Override
    public void run() {
        testPing();
        testDownload();
        addToCvs();
    }

    public void testDownload(){
        try{
            byte[] bytes;
            long[] values = new long[3];
            //mereni udelame trikrat
            for(int i=0;i<3;i++){
            socket = new Socket(dstAddress, dstPort);

            long currentTime = System.currentTimeMillis();
            InputStream inputStream = socket.getInputStream();
            //prijeti obrazku
            File file = new File(Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS) + "/test.pdf");

            ObjectInputStream ois = new ObjectInputStream(inputStream);
            bytes = (byte[]) ois.readObject();
            currentTime = System.currentTimeMillis() - currentTime;
            values[i] =  (bytes.length*8*(1000/currentTime)/1024/1024);

            }
            //textview.setText(textview.getText() + "\nPrijato " + bytes.length + "bytes in " + currentTime + " ms" );
            //speedDownlod = (bytes.length*8*(1000/currentTime)/1024/1024);
            //final String message = "\nPrijato " + bytes.length + "bytes in " + currentTime + " ms - " + speedDownlod + " Mbps\nPing: " + this.pingTime;
            //spocitame prumer
            long cumulate = 0;
            int divide = 0;
            for(long val: values){
                if(val!=-1){
                    cumulate =+ val;
                    divide++;
                }
            }
            //arit prumer
            if(cumulate==0 || divide == 0){
                speedDownlod = -1;
            }else{
                speedDownlod = cumulate / divide;
            }

        }catch(Exception e){
            final Exception er = e;

        }
    }

    public void testPing(){
        pingTime = -1;
        long time;
        try {
            in = getByName(dstAddress);
            time = System.currentTimeMillis();
            if (in.isReachable(TIMEOUT)) {
                pingTime = System.currentTimeMillis() - time;
            }else{
                pingTime = -1;
            }
        }catch (Exception  e) {
            pingTime = -1;
        }
    }

    private void addToCvs(){
        File sdCard = Environment.getExternalStorageDirectory();
        File dir = new File (sdCard+ File.separator +"diplomka");
        if(!dir.exists()){
            dir.mkdir();
        }
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String currentDateTime = dateFormat.format(new Date());
        File file  = new File(dir, this.csvFileName + ".csv");
        try {
            //writer = new CSVWriter(new FileWriter(file),'\t');
            csvWriter = new CSVWriter(new FileWriter(file,true));
        } catch (IOException e) {
            e.printStackTrace();
        }
        List<String[]> rows = new ArrayList<String[]>();
        String[] columns = new String[8];
        columns[0] = String.valueOf(Calendar.getInstance().getTime().getTime());
        columns[1] = wifiManager.getConnectionInfo().getSSID();
        columns[2] = String.valueOf(speedDownlod);
        columns[3] = String.valueOf(pingTime);
        columns[4] = String.valueOf(wifiManager.getConnectionInfo().getFrequency());
        columns[5] = String.valueOf(wifiManager.getConnectionInfo().getIpAddress());
        columns[6] = String.valueOf(wifiManager.getConnectionInfo().getLinkSpeed());
        columns[7] = wifiManager.getConnectionInfo().getMacAddress();
        rows.add(columns);
        csvWriter.writeNext(columns);
        try {
            csvWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
