package diplomka.pef.czu.diplomka.threads;

import android.app.IntentService;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.os.IBinder;
import android.util.Log;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.TimeUnit;

import diplomka.pef.czu.diplomka.NetworkList.NetworkInfo;

/**
 * Created by Roman on 6.3.2018.
 */

public class TimerBroadcastService  extends IntentService {
    CountDownTimer cdt = null;
    WifiManager wifiManager;
    MeasureAndStoreThread measureThtead;
    private Bundle extras;
    private String csvFileName;
    private long interval;
    private String[] SSIDs;
    public static final String COUNTDOWN_BR = "your_package_name.countdown_br";
    public static final String FINISH_BR = "your_package_name.finish_br";
    Intent coundownIntent = new Intent(COUNTDOWN_BR);
    Intent finishCounIntent = new Intent(FINISH_BR);
    private WifiManager.MulticastLock lock;


    public TimerBroadcastService() {
        super("TimerBroadcastService");
    }

    @Override
    public void onCreate() {
        super.onCreate();
        wifiManager = (WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE);
        //tohle by melo nechat wifi aktivni kdy se vypne displej
        lock = wifiManager.createMulticastLock("lockWiFiMulticast");
        lock.setReferenceCounted(false);
        lock.acquire();
        measureThtead = new MeasureAndStoreThread(8080,null,wifiManager,csvFileName);

    }

    @Override
    public void onDestroy() {
        cdt.cancel();
        lock.release();
        super.onDestroy();
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {

        extras = intent.getExtras();
        csvFileName = extras.getString("csvFileName");
        interval = extras.getLong("interval");
        ArrayList<NetworkInfo> parcelableArray ;
        parcelableArray = extras.getParcelableArrayList("networks");
        SSIDs = new String[parcelableArray.size()];
        for(int i=0;i<parcelableArray.size();i++){
            SSIDs[i] = ((NetworkInfo)parcelableArray.get(i)).getSSID();
        }







        cdt = new CountDownTimer(interval, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {


                coundownIntent.putExtra("countdown", millisUntilFinished);
                sendBroadcast(coundownIntent);

            }

            @Override
            public void onFinish() {
                sendBroadcast(finishCounIntent);
                List<WifiConfiguration> wifiConf = wifiManager.getConfiguredNetworks();
                //projedem vsechny ssid ktere chceme merit
                for(String SSID : SSIDs){
                    //hledame jestli ma android sit ulozenou
                    for(final WifiConfiguration wc : wifiConf){
                        //nasli sme a jdem na mereni
                        if(wc.SSID.contains(SSID) ) {
                            wifiManager.disconnect();
                            wifiManager.enableNetwork(wc.networkId, true);
                            wifiManager.reconnect();
                            wifiManager.reassociate();
                            ConnectivityManager mgr = (ConnectivityManager) getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
                            android.net.NetworkInfo networkInfo = mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                            //cekame dokud se wifi nepripoji
                            while (!networkInfo.isConnected()) {
                                networkInfo = mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                            }
                            measureThtead = new MeasureAndStoreThread(8080,null,wifiManager,csvFileName);
                            measureThtead.start();
                            while(measureThtead.getState() != Thread.State.TERMINATED){}

                        }

                    }

                }
                this.start();

            }
        };

        cdt.start();



        return super.onStartCommand(intent, flags, startId);
    }



    @Override
    public IBinder onBind(Intent arg0) {
        return null;
    }

    //vytahne extras z Bndle
    private void getExtras(Bundle extras){

        csvFileName = extras.getString("csvFileName");
        interval = extras.getLong("interval");
        ArrayList<NetworkInfo> parcelableArray ;
        parcelableArray = extras.getParcelableArrayList("networks");
        SSIDs = new String[parcelableArray.size()];
        for(int i=0;i<parcelableArray.size();i++){
            SSIDs[i] = ((NetworkInfo)parcelableArray.get(i)).getSSID();
        }
    }


    //tohle kdyztak smaz a IntentService prepis na Intent

    @Override
    protected void onHandleIntent(Intent intent) {
        wifiManager = (WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE);
        //tohle by melo nechat wifi aktivni kdy se vypne displej
        lock = wifiManager.createMulticastLock("lockWiFiMulticast");
        lock.setReferenceCounted(false);
        lock.acquire();
        measureThtead = new MeasureAndStoreThread(8080,null,wifiManager,csvFileName);

        extras = intent.getExtras();
        csvFileName = extras.getString("csvFileName");
        interval = extras.getLong("interval");
        ArrayList<NetworkInfo> parcelableArray ;
        parcelableArray = extras.getParcelableArrayList("networks");
        SSIDs = new String[parcelableArray.size()];
        for(int i=0;i<parcelableArray.size();i++){
            SSIDs[i] = ((NetworkInfo)parcelableArray.get(i)).getSSID();
        }


        cdt = new CountDownTimer(interval, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {


                coundownIntent.putExtra("countdown", millisUntilFinished);
                sendBroadcast(coundownIntent);

            }

            @Override
            public void onFinish() {
                sendBroadcast(finishCounIntent);
                List<WifiConfiguration> wifiConf = wifiManager.getConfiguredNetworks();
                //projedem vsechny ssid ktere chceme merit
                for(String SSID : SSIDs){
                    //hledame jestli ma android sit ulozenou
                    for(final WifiConfiguration wc : wifiConf){
                        //nasli sme a jdem na mereni
                        if(wc.SSID.contains(SSID) ) {
                            wifiManager.disconnect();
                            wifiManager.enableNetwork(wc.networkId, true);
                            wifiManager.reconnect();
                            wifiManager.reassociate();
                            ConnectivityManager mgr = (ConnectivityManager) getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
                            android.net.NetworkInfo networkInfo = mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                            //cekame dokud se wifi nepripoji
                            while (!networkInfo.isConnected()) {
                                networkInfo = mgr.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
                            }
                            measureThtead = new MeasureAndStoreThread(8080,null,wifiManager,csvFileName);
                            measureThtead.start();
                            while(measureThtead.getState() != Thread.State.TERMINATED){}

                        }

                    }

                }
                this.start();

            }
        };

        cdt.start();
        while(true){}

    }

}

