package diplomka.pef.czu.diplomka.viewFragments;

import android.content.Context;
import android.os.Bundle;
import android.os.Environment;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ListView;
import java.io.File;
import java.util.ArrayList;
import java.util.List;
import android.widget.AdapterView.OnItemClickListener;
import czu.pef.diplomka.R;
import diplomka.pef.czu.diplomka.other.FileItemListAdapter;

/**
 * Created by Roman on 11.2.2018.
 */

public class LoadDataFragment extends Fragment implements OnItemClickListener {

    // Activity must implement this interface
    public interface OnItemListSelectedListener {
         void onItemListSelected(int position);
    }

    private OnItemListSelectedListener mcallBack;
    private ListView csvFilesListView; //list csv souboru
    private FileItemListAdapter itemListAdapter;
    private List<Integer> selectedItems; // udrzuje indexy oznacenych itemu

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        super.onCreateView(inflater, container, savedInstanceState);
        View rootView = inflater.inflate(R.layout.loaddatafragment, container, false);
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        csvFilesListView = (ListView)view.findViewById(R.id.filesList);
        itemListAdapter = new FileItemListAdapter(getContext(),getCsvFileList());
        csvFilesListView.setAdapter(itemListAdapter);
        csvFilesListView.setOnItemClickListener(this);
        selectedItems = new ArrayList<>();

    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        mcallBack = (OnItemListSelectedListener)getActivity();

    }

    @Override
    public void onItemClick(AdapterView<?> adapterView, View view, int i, long l) {
        mcallBack.onItemListSelected(i);
    }

    public void clickListViewItem(int position){
        boolean value = selectedItems.contains(position);
        if(value){
            int i =  selectedItems.indexOf(position);
            selectedItems.remove(i);
        }else{
            selectedItems.add(new Integer(position));
        }
        value = !value;
        csvFilesListView.setItemChecked(position, value);
    }

    private ArrayList<String> getCsvFileList(){
        ArrayList<String> filesName = new ArrayList<>();
        File directory = new File (Environment.getExternalStorageDirectory() + File.separator +"diplomka");
        for(File f : directory.listFiles()){
            if(f.getName().endsWith(".csv")){
                filesName.add(f.getName());
            }

        }
        return filesName;
    }
    public String[] getSelectedFileNames(){
        String[] outArray = new String[selectedItems.size()];
        for(int i=0; i< selectedItems.size();i++){
            outArray[i] = itemListAdapter.getItem(selectedItems.get(i).intValue());
        }

        return outArray;
    }
}
