package diplomka.pef.czu.diplomka.viewFragments;

import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.TimePickerDialog;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.format.DateFormat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.NumberPicker;
import android.widget.RadioGroup;
import android.widget.TimePicker;

import java.util.Calendar;

import czu.pef.diplomka.R;

/**
 * Created by Roman on 11.2.2018.
 */

public class SetMeasureFragment extends Fragment  {

    private static EditText fileName;
    private RadioGroup radioGroup;
    private NumberPicker minutesPicker;
    private NumberPicker secondsPicker;
    int yearPicked = 0;
    int monthPicked = 0;
    int dayPicked = 0;
    int hoursPicked = 0;
    int minutesPicked = 0;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        super.onCreateView(inflater, container, savedInstanceState);
        View rootView = inflater.inflate(R.layout.setmeasurefragment, container, false);
        fileName = rootView.findViewById(R.id.csvfilename);

        //NumberPicker hoursPicker = (NumberPicker)rootView.findViewById(R.id.hours);
        //hoursPicker.setMinValue(0);
        //hoursPicker.setMaxValue(23);
        //hoursPicker.setWrapSelectorWheel(true);
        init(rootView);

        return rootView;
    }

    private void init(View rootView){
        minutesPicker = (NumberPicker)rootView.findViewById(R.id.minutes);
        minutesPicker.setMinValue(0);
        minutesPicker.setMaxValue(59);
        minutesPicker.setWrapSelectorWheel(true);
        secondsPicker = (NumberPicker)rootView.findViewById(R.id.seconds);
        secondsPicker.setMinValue(0);
        secondsPicker.setMaxValue(59);
        secondsPicker.setValue(30);
        secondsPicker.setWrapSelectorWheel(true);
        radioGroup = (RadioGroup) rootView.findViewById(R.id.radioGroup);
        radioOnCheckedListener();
        final Calendar c = Calendar.getInstance();
        yearPicked = c.get(Calendar.YEAR);
        monthPicked = c.get(Calendar.MONTH);
        dayPicked = c.get(Calendar.DAY_OF_MONTH);
        hoursPicked = c.get(Calendar.HOUR_OF_DAY);
        minutesPicked = c.get(Calendar.MINUTE);
    }
    public EditText getCsvFileName(){
        return fileName;
    }

    //zaregistruje listenera na radio buttony
    private void radioOnCheckedListener(){
        radioGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener()
        {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                // checkedId is the RadioButton selected
                switch(checkedId) {
                    case R.id.radio_1:
                        // switch to fragment 1
                        break;
                    case R.id.radio_2:
                        // Fragment 2
                        break;
                    case R.id.radio_3:
                        // Get Current Date
                        /*final Calendar c = Calendar.getInstance();
                        int mYear = c.get(Calendar.YEAR);
                        int mMonth = c.get(Calendar.MONTH);
                        int mDay = c.get(Calendar.DAY_OF_MONTH);
                        int mHour = c.get(Calendar.HOUR_OF_DAY);
                        int mMinute = c.get(Calendar.MINUTE);*/
                        //createDialog();
                        new TimePickerDialog(getActivity(), timePickerListener, hoursPicked, minutesPicked, false).show();
                        new DatePickerDialog(getActivity(), datePickerListener, yearPicked, monthPicked, dayPicked).show();
                        break;

                }
            }
        });

    }

    public void createDialog() {
                // set time picker as current time
                 new TimePickerDialog(getActivity(), timePickerListener, 14, 1, false).show();

    }

    private TimePickerDialog.OnTimeSetListener timePickerListener = new TimePickerDialog.OnTimeSetListener() {
        @Override
        public void onTimeSet(TimePicker timePicker, int i, int i1) {
            hoursPicked = i;
            minutesPicked = i1;
        }
    };

    private DatePickerDialog.OnDateSetListener datePickerListener = new DatePickerDialog.OnDateSetListener() {

        @Override
        public void onDateSet(DatePicker datePicker, int i, int i1, int i2) {
            yearPicked= i;
            monthPicked = i1;
            dayPicked = i2;

        }

    };

    //return interval in millicesonds
    public long getInterval(){
        return (minutesPicker.getValue()*60*1000)+(secondsPicker.getValue()*1000);
    }

}
